﻿@model IEnumerable<ExploreApilkasiCuti.Models.MasterJenisPengajuan>

@{
    ViewBag.Title = "Master Jenis Pengajuan";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@section HeadLibrary{
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <!-- Toastr -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
}

<style>
    .content-table {
        border-collapse: collapse;
        margin: 25px 0;
        min-width: 1000px;
        box-shadow: 0 0 20px rgba(0, 0, 0, 0.15);
        width: 100%;
    }

    /* if the browser window is at least 800px-s wide: */
    @@media screen and (min-width: 800px) {
        table {
            width: 90%;
        }
    }

    /* if the browser window is at least 1000px-s wide: */
    @@media screen and (min-width: 1000px) {
        table {
            width: 80%;
        }
    }

    .content-table thead tr {
        background-color: #10ad21;
        color: #ffffff;
        text-align: left;
    }

    .content-table tr, td {
        border: solid black 0.5px;
    }

    .content-table th, td {
        padding: 12px 10px;
        border: solid black 0.5px;
    }

    #dataMasterJabatan_filter .iconSearch {
        float: left;
        display: inline-block;
    }

    .help-block {
        color: red;
    }

    .has-error {
        color: red;
    }
</style>


<!-- Main content -->
<div class="card">
    <div class="card-header">
        <h3 class="card-title"> Master Data Jenis Pengajuan</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <div class="row">
            <button type="button" class="btn btn-success" data-toggle="modal" data-target="#modalAdd">
                <i class="fa fa-plus-circle fa"></i>  Tambah Data
            </button>
            <div class="mt-3 col-md-12"></div>
        </div>
        <table id="dataMasterJenisPengajuan" class="table table-bordered table-striped table-hover" role="grid" aria-describedby="dataMasterJenisPengajuan_info">
            <thead>
                <tr>
                    <th>
                        @Html.DisplayName("ID Jenis Pengajuan")
                    </th>
                    <th>
                        @Html.DisplayName("Nama Pengajuan")
                    </th>
                    <th>
                        @Html.DisplayName("Durasi")
                    </th>
                    <th>
                        @Html.DisplayName("Action")
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                </tr>
                @*
                    @foreach (var item in Model)
                    {
                        <tr>
                            <td>
                                @Html.DisplayFor(modelItem => item.id_jenis_pengajuan)
                            </td>
                            <td>
                                @Html.DisplayFor(modelItem => item.nama_pengajuan)
                            </td>
                            <td>
                                @Html.DisplayFor(modelItem => item.durasi)
                            </td>
                            <td>
                                <button type="button" data-toggle="modal" data-target="#modalEdit" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light" style="margin-right: 5px;" onclick="editJenisPengajuan(\'' + data.id_jenis_pengajuan + '\')"><i class="icon-edit"></i></button><button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light" onclick="deleteJenisPengajuan(\'' + data.id_jenis_pengajuan + '\')"><i class="feather icon-trash"></i></button>
                            </td>
                        </tr>
                    }
                *@
            </tbody>
        </table>

    </div>
    <!-- /.card-body -->
</div>
<!-- /.card -->
<!-- /.modal Add start -->
<div class="modal fade" id="modalAdd">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Input Data Jenis Pengajuan</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <!-- form start -->
                <form role="form">
                    <div class="card-body">
                        <div class="form-group">
                            <label for="id_jenis_pengajuan">ID Jenis Pengajuan</label>
                            <input type="text" class="form-control" id="id_jenis_pengajuan" placeholder="Masukkan ID Jenis Pengajuan">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="nama_pengajuan">Nama Pengajuan</label>
                            <input type="text" class="form-control" id="nama_pengajuan" placeholder="Masukkan Nama Pengajuan">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="durasi">Durasi</label>
                            <input type="text" class="form-control" id="durasi" placeholder="Masukkan Durasi">
                            <span class="help-block"></span>
                        </div>
                    </div>
                    <!-- /.card-body -->

                    <div class="modal-footer justify-content-around">
                        <button type="button" id="btnAdd" class="btn btn-primary" style="width:35%">Simpan Data</button>
                        <button type="button" class="btn btn-danger" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal Add end -->
<!-- /.modal Edit start -->
<div class="modal fade" id="modalEdit">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Edit Data Jenis Pengajuan</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <!-- form start -->
                <form role="form">
                    <div class="card-body">
                        <div class="form-group">
                            <label for="edit_id_jenis_pengajuan">ID Jenis Pengajuan</label>
                            <input type="text" class="form-control" id="edit_id_jenis_pengajuan" required disabled>
                        </div>
                        <div class="form-group">
                            <label for="edit_nama_pengajuan">Nama Pengajuan</label>
                            <input type="text" class="form-control" id="edit_nama_pengajuan">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="edit_durasi">Durasi</label>
                            <input type="text" class="form-control" id="edit_durasi">
                            <span class="help-block"></span>
                        </div>
                    </div>
                    <!-- /.card-body -->
                    <div class="modal-footer justify-content-around">
                        <button type="button" id="btnUpdate" class="btn btn-primary" style="width:35%">Simpan</button>
                        <button type="button" class="btn btn-danger" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal edit end -->
<!-- /.content -->

@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Select2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/select2/js/select2.full.min.js")"></script>
    
}

@section AdditionalScript{
    <script>

        var rowId;
        var rowName;
        var masterJenisPengajuanTable;

        jQuery(document).ready(function ($) {


            masterJenisPengajuanTable = $("#dataMasterJenisPengajuan").DataTable({

                "responsive": true,
                "autoWidth": false,

                "ajax": {
                    "url": '@Url.Action("GetDatatableAll")',
                    "type": "POST",
                    "datatype": "JSON"
                },
                "columns": [
                    { "data": "id_jenis_pengajuan", "name": "id_jenis_pengajuan" },
                    { "data": "nama_pengajuan", "name": "nama_pengajuan" },
                    { "data": "durasi", "name": "durasi" },
                    {
                        data: null, render: function (data, type, row) {
                            return '<button type="button" data-toggle="modal" data-target="#modalEdit" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light" style="margin-right: 5px;" onclick="editJenisPengajuan(\'' + data.id_jenis_pengajuan + '\')"><i class="fas fa-edit"></i></button><button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light" onclick="deleteJenisPengajuan(\'' + data.id_jenis_pengajuan + '\')"><i class="fa fa-trash-alt"></i></button>'

                        }

                    },
                    //{ "data": "created_by", "name": "created_by", "visible": false },
                    //{ "data": "created_date", "name": "created_date", "visible": false },
                    //{ "data": "changed_by", "name": "changed_by", "visible": false },
                    //{ "data": "changed_date", "name": "changed_date", "visible": false },
                ],

            });
        });

        $('#btnAdd').on('click', function () {
            $(".err-cutiBulanan").css('color: black');
            $(".form-group").removeClass('has-error');
            $(".help-block").empty()
            var validate = true;
            if ($("#id_jenis_pengajuan").val() == "" || !$("#id_jenis_pengajuan").val().replace(/\s/g, '').length) {
                //$('#id_jenis_pengajuan').parent().addClass('has-error');
                $('#id_jenis_pengajuan').next().text('ID Jenis Pengajuan Harus diisi');
                validate = false;
            }
            if ($("#nama_pengajuan").val() == "" || !$("#nama_pengajuan").val().replace(/\s/g, '').length) {
                //$('#nama_pengajuan').parent().addClass('has-error');
                $('#nama_pengajuan').next().text('Nama Jenis Pengajuan Harus diisi');
                validate = false;
            }
            if ($("#durasi").val() == "" || !$("#durasi").val().replace(/\s/g, '').length) {
                //$('#durasi').parent().addClass('has-error');
                $('#durasi').next().text('Durasi Harus diisi');
                validate = false;
            }
            if (!validate) return;
            $.ajax({
                    url: '@Url.Action("Create")',
                    method: "POST",
                    dataType: "JSON",
                    data: {
                        "id_jenis_pengajuan": $('#id_jenis_pengajuan').val(),
                        "nama_pengajuan": $('#nama_pengajuan').val(),
                        "durasi": $('#durasi').val(),
                        //"created_by": $('#created_by').val(),
                        //"created_date": $('#created_date').val(),
                        //"changed_by": $('#changed_by').val(),
                        //"changed_date": $('#changed_date').val()
                    },
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Saving Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        Swal.close();
                        if (result.metaData.code === '200') {
                            $('#modalAdd').modal('hide');
                            masterJenisPengajuanTable.ajax.reload();
                            //masterKaryawanTable.clear().draw();
                            return toastr.success('Data berhasil ditambahkan.', 'Success!', { "timeOut": 5000 });
                        } else {
                            return toastr.warning('Data gagal ditambahkan.', 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        });

        $('#btnUpdate').on('click', function () {
            $(".err-cutiBulanan").css('color: black');
            $(".form-group").removeClass('has-error');
            $(".help-block").empty()
            var validate = true;
            
            if ($("#edit_nama_pengajuan").val() == "" || !$("#edit_nama_pengajuan").val().replace(/\s/g, '').length) {
                //$('#edit_nama_pengajuan').parent().addClass('has-error');
                $('#edit_nama_pengajuan').next().text('Nama Jenis Pengajuan Harus diisi');
                validate = false;
            }
            if ($("#edit_durasi").val() == "" || !$("#edit_durasi").val().replace(/\s/g, '').length) {
                //$('#edit_durasi').parent().addClass('has-error');
                $('#edit_durasi').next().text('Durasi Harus diisi');
                validate = false;
            }
            if (!validate) return;
            $.ajax({
                    url: '@Url.Action("Update")',
                    method: "POST",
                    dataType: "JSON",
                    data: {
                        "id_jenis_pengajuan": $('#edit_id_jenis_pengajuan').val(),
                        "nama_pengajuan": $('#edit_nama_pengajuan').val(),
                        "durasi": $('#edit_durasi').val(),
                        //"created_by": $('#edit_created_by').val(),
                        //"created_date": $('#edit_created_date').val(),
                    },
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Saving Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        Swal.close();
                        if (result.metaData.code === '200') {
                            $('#modalEdit').modal('hide');
                            masterJenisPengajuanTable.ajax.reload();
                            //masterKaryawanTable.clear().draw();
                            return toastr.success('Data berhasil diperbarui.', 'Success!', { "timeOut": 5000 });
                        } else {
                            return toastr.warning('Data gagal diperbarui.', 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        });

        function editJenisPengajuan(id_jenis_pengajuan) {
            $.ajax({
                url: '@Url.Action("GetDataByID")' + "/" + id_jenis_pengajuan,
                    method: "POST",
                    dataType: "JSON",
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Loading...',
                            html: "Loading Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            Swal.close();
                            $('#edit_id_jenis_pengajuan').val(result.response[0].id_jenis_pengajuan);
                            $('#edit_nama_pengajuan').val(result.response[0].nama_pengajuan).trigger('change');
                            $('#edit_durasi').val(result.response[0].durasi).trigger('change');
                            //$('#edit_created_by').val(result.response[0].created_by);
                            //$('#edit_created_date').val(result.response[0].created_date);
                            //$('#edit_changed_by').val(result.response[0].changed_by);
                            //$('#edit_changed_date').val(result.response[0].changed_date);
                            $('#modalEdit').modal('show');
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        }
        function deleteJenisPengajuan(id_jenis_pengajuan) {
            Swal.fire({
                title: 'Perhatian',
                text: "Apakah anda Yakin menghapus data ?" ,
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Hapus Data',
                confirmButtonClass: 'btn btn-primary',
                cancelButtonClass: 'btn btn-danger ml-1',
                showLoaderOnConfirm: true,
                buttonsStyling: false,
                preConfirm: (delete_part) => {
                    return fetch('@Url.Action("DeleteJenisPengajuan")' + "/" + id_jenis_pengajuan, {
                        method: 'POST'
                    }).then(response => {
                        if (!response.ok) {
                            return toastr.error(response.statusText, 'Failed!', { "timeOut": 5000 });
                        }
                        return response.json();
                    }).then(result => {
                        if (result.metaData.code === '200') {
                            masterJenisPengajuanTable.ajax.reload();
                            return toastr.success('Row has been deleted.', 'Success!', { "timeOut": 5000 });
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: ${error}`
                        )
                    })
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }
    </script>
}